#include "camera.h"
#include "cloth.h"

#include <GL/glut.h>


float frustum[6] = { -0.45, 0.45, -0.45, 0.45, 1, 100 };


float eyeX = 0;
float eyeY = 0;
float eyeZ = 20;
float upX  = 0;
float upY  = 1;
float upZ  = 0;


float camera_pitch      = 0;
float camera_theta      = 0;
float camera_zoom       = 0;
int   camera_mode       = C_STATIONARY;


void position_camera ()
{
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glPushMatrix();

  if (camera_mode == C_STATIONARY)
  {
      gluLookAt(eyeX, eyeY, eyeZ, 0, 0, 0, upX, upY, upZ);

      glTranslatef(eyeX * camera_zoom,
                   eyeY * camera_zoom,
                   eyeZ * camera_zoom);
      glRotatef(camera_pitch, 1, 0, 0);
      glRotatef(camera_theta, 0, 0, 1);
  }
  else if (camera_mode == C_TRACK)
  {
      gluLookAt(eyeX, eyeY, eyeZ, 0, 0, 0, upX, upY, upZ);

      glTranslatef(eyeX * camera_zoom,
                   eyeY * camera_zoom,
                   eyeZ * camera_zoom);
      glRotatef(camera_pitch, 1, 0, 0);
      glRotatef(camera_theta, 0, 0, 1);

      int center = (CLOTH_WIDTH*CLOTH_HEIGHT - 1) / 2 * 3;
      glTranslatef(-cloth_vertices[center + 0],
                   -cloth_vertices[center + 1],
                   -cloth_vertices[center + 2]);
  }
}

