#include "lights.h"
#include <GL/glut.h>


static float zeroes[4] = { 0.0, 0.0, 0.0, 0.0 };

float ambient[4] = { 0.0, 0.0, 0.0, 1.0 };

// point light in the room
float light0[3][4] = { { 0.7, 0.7, 0.7, 1 },
                       { 0.5, 0.5, 0.5, 1 },
                       { 9, 9, 9, 1 } };

// point light in the room
float light1[3][4] = { { 0.7, 0.7, 0.7, 1 },
                       { 0.5, 0.5, 0.5, 1 },
                       { -9, -9, 9, 1 } };


void make_lights ()
{
  glEnable(GL_LIGHTING);

  glLightfv(GL_LIGHT0, GL_AMBIENT,  zeroes);
  glLightfv(GL_LIGHT0, GL_DIFFUSE,  light0[0]);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light0[1]);
  glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.1);
  glEnable(GL_LIGHT0);

  glLightfv(GL_LIGHT1, GL_AMBIENT,  zeroes);
  glLightfv(GL_LIGHT1, GL_DIFFUSE,  light1[0]);
  glLightfv(GL_LIGHT1, GL_SPECULAR, light1[1]);
  glLightf(GL_LIGHT1, GL_LINEAR_ATTENUATION, 0.1);
  glEnable(GL_LIGHT1);

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);

  place_lights();
}


void place_lights ()
{
  glLightfv(GL_LIGHT0, GL_POSITION, light0[2]);
  glLightfv(GL_LIGHT1, GL_POSITION, light1[2]);
}


void set_ambient_light (float r, float g, float b)
{
  ambient[0] = r;
  ambient[1] = g;
  ambient[2] = b;
  ambient[3] = 1;

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient);
}
